function ad3TrailerToFitsHeader, trailer, hdr
COMPILE_OPT IDL2
  hdr = adTrailerToFitsHeader(trailer, hdr)

  sxaddpar, hdr, 'fp_id', string(trailer.id), 'ADHOC identification'
  sxaddpar, hdr, 'fp_order', trailer.p0, 'PF interference order'
  sxaddpar, hdr, 'fp_l_ref', trailer.xlp, 'Reference lambda for fp_order (Angstrom)'
  sxaddpar, hdr, 'fp_b_l', trailer.xl1, 'Lambda of the first channel (Angstrom)'
  sxaddpar, hdr, 'fp_b_r', trailer.vr1, 'Radial velocity of the first channel'
  sxaddpar, hdr, 'fp_i_a', trailer.xi1, 'Interfringe (Angstrom)'
  sxaddpar, hdr, 'fp_i_v', trailer.xik, 'Interfringe (km/s)'
  sxaddpar, hdr, 'fp_l_re', trailer.xl0, 'Lmabda rest: observed zero-velocity lambda (Angstrom)'
  sxaddpar, hdr, 'fp_m_rv', trailer.vr0, 'Mean RV of the object (km/s)'
  sxaddpar, hdr, 'fp_h_co', trailer.corrv, 'Heliocentric correction for the object (km/s)'

  return, hdr
end
