function adToFits, ad, fits, hdr, fits_xyz=fx, build_names=bn
COMPILE_OPT IDL2

  if ((n_elements(bn) eq 0) and (n_elements(fits) eq 0)) then bn=1
  if ((n_elements(bn) eq 0) and (n_elements(fits) ne 0)) then bn=0

  if bn eq 1 then begin
    fits = ad
    for i=0, n_elements(fits)-1 do begin
      fits[i] = string((byte(fits[i]))[0:strpos(fits[i], '.', /reverse_search)])+'fits'
    endfor
  endif

  n = n_elements(ad)<n_elements(fits)
  n = (n_elements(hdr) le 1)?n:n<n_elements(hdr)
  success = 0

  for i=0, n-1 do begin
    if strmatch(ad[i], '*.ad2') then begin
      success = success + ad2ToFits(ad[i], fits[i], hdr)
    endif else begin
      success = success + ad3ToFits(ad[i], fits[i], hdr, fits_xyz=fx)
    endelse
  endfor

  return, success

end
