function readAd, filename, trailer, xyz=re
COMPILE_OPT IDL2
  info = file_info(filename)

  testgz = strsplit(filename, '.', /extract)
  testgz = testgz[n_elements(testgz)-1]

  if (info.exists eq 0) or (info.read eq 0) or (testgz eq 'gz') then begin
    ; On regarde si plutot le fichier est .ad?.gz...
    if (testgz ne 'gz') then begin
      filenametest = filename + '.gz'
      info = file_info(filenametest)
    endif else begin
      filenametest = filename
    endelse

    if (info.exists eq 0) or (info.read eq 0) then return, -1
    if (!version.os_family ne 'unix') then return, -1

    testgz = 'gz'

    filename = filenametest
    spawn, 'gzip -cd ' + filename, unit=unit
    spawn, 'gzip -l ' + filename, output
    output = strsplit(output[1], ' ', /extract)
    size = ulong64(output[1])
    toto = fltarr((size-256)/4, /nozero)
    readu, unit, toto
    toto = 0
  endif else begin
    openr, unit, filename, /get_lun
    if (n_elements(unit) eq 0) then begin
      print, 'Unable to open ' + filename + ' for reading'
      return, -1
    endif
    size = info.size
    point_lun, unit, size-256
  endelse

  trailer = {ad3_trailer}

  readu, unit, trailer

  free_lun, unit

  return, (trailer.nbdim eq 2)?readad2(filename, trailer):readad3(filename, trailer, xyz=re)
end
