
function rvMap, cube, trailer, mono, continum, width, baryHeight, gCube
COMPILE_OPT IDL2
  c = 299792.458D

  sz = size(cube)

  mono = fltarr(sz[2], sz[3], /nozero)
  rv = fltarr(sz[2], sz[3], /nozero)
  continum = fltarr(sz[2], sz[3], /nozero)
  width = fltarr(sz[2], sz[3], /nozero)
  baryHeight = fltarr(sz[2], sz[3], /nozero)
  gCube = fltarr(sz[1], sz[2], sz[3], /nozero)

  fwhmFast = 1/(2*sqrt(2*alog(2)))
  gaussianFast = findgen(sz[1])
;  raielarge = fltarr(sz[1]*2)
;  xx = findgen(sz[1]*2)-sz[1]/2

  channelWidth = trailer.xi1 / sz[1]
;  raiett = fltarr(sz[1]*2)

  for x=0, sz[2]-1 do begin
    for y=0, sz[3]-1 do begin
      raie = cube[*,x,y]

      ; Pour les autres cartes, on prend le niveau de continu a 0.5
;      sn = computeSignalNoiseValue(raie, 0.5, signal, noise, cont, bary, start, stop, raiet)
      
      result = baryc(raie)

      ; Pour deternimer le largeur a mi-hauteur, uncomment below
      ; On y va simplement pour le moment...
;      if start gt stop then begin
;        raiettt = fltarr(sz[1]*2)
;        raiettt[0:sz[1]/2-1] = raiet[sz[1]/2:sz[1]-1]
;        raiettt[sz[1]/2:sz[1]*1.5-1] = raiet
;        raiettt[sz[1]*1.5:sz[1]*2-1] = raiet[0:sz[1]/2-1]
;        raiettt = raiett[start-sz[1]/2:stop+sz[1]/2]
;      endif else begin
;        raiettt = raiet[start:stop]
;      endelse

;      hm = max(raiettt)/2
;      val = minmax(where(raiettt ge hm))
;      val = val + start

;      if (val[0] eq val[1]) then begin
;        width[x,y] = 0
;        goto, fin_width
;      endif

;      raiett[0:sz[1]/2-1] = raie[sz[1]/2:sz[1]-1]
;      raiett[sz[1]/2:sz[1]*1.5-1] = raie
;      raiett[sz[1]*1.5:sz[1]*2-1] = raie[0:sz[1]/2-1]

;      ; On va interpoler de start-1 a
;      ; start+1 pour trouver la valeur de canal au niveau du continu
;      raiei = raiett[sz[1]/2+val[0]-1:sz[1]/2+val[0]+1]
;      if ((raiei[0] ge raiei[1]) or (raiei[1] ge raiei[2])) then begin
;        w1 = val[0]
;      endif else begin
;        fit = linfit([val[0]-1, val[0], val[0]+1], raiei)
;        if fit[1] eq 0 then begin
;          width[x,y]=0
;          goto, fin_width
;        endif
;        w1 = (cont - fit[0])/fit[1]
;        if (w1 le -0.5*sz[1]) or (w1 ge 1.5*sz[1]) then w1 = val[0]
;      endelse

;      raiei = raiett[sz[1]/2+val[1]-1:sz[1]/2+val[1]+1]
;      if ((raiei[2] ge raiei[1]) or (raiei[0] ge raiei[1])) then begin
;        w2 = val[1]
;      endif else begin
;        fit = linfit([val[1]-1, val[1], val[1]+1], raiei)
;        if fit[1] eq 0 then begin
;          width[x,y]=0
;          goto, fin_width
;        endif
;        w2 = (cont -fit[0])/fit[1]
;        if (w2 le -0.5*sz[1]) or (w2 ge 1.5*sz[1]) then w2 = val[1]
;      endelse

;      w1 = (w1 gt w2)?w1-sz[1]:w1
;
;      width[x,y] = w2-w1
;      fin_width:

      mono[x,y] = result[2]
      continum[x,y] = result[3]
      width[x,y] = result[5]
      baryHeight[x,y] = result[1]
      baryLambda = result[0] * channelWidth + trailer.xl1
      z = (baryLambda / trailer.xl0) - 1
      rv[x,y] = ((z + 1)^2 - 1)/((z + 1)^2 + 1) * c + trailer.corrv

      if (result[2] eq 0) and (result[3] eq 0) and (result[0] eq 0) then begin
        rv[x,y] = -3.1e+38
      endif

;      gCube[*, x, y] = makeGaussian([2*result[1], result[0], result[5]*fwhmFast, result[3]], gaussianFast)
      ;rv[x,y] = z * c + trailer.corrv

      ;raiet = raie-min(raie)
;      tot = total(raiet)
;      if tot eq 0 then begin
;        confidence[x,y]=0
;      endif else begin
;        confidence[x,y] = (start gt stop)?total(raiet[0:stop])+total(raiet[stop:n_elements(raiet)-1]):total(raiet[start:stop])
;        confidence[x,y] = confidence[x,y]*(100.0/tot)
;      endelse

    endfor
  endfor

  return, rv

end

;function rvMap, cube, level, trailer, mono, continum, width
;COMPILE_OPT IDL2
;  c = 299792.458D

;  sz = size(cube)

;  mono = fltarr(sz[2], sz[3])
;  rv = fltarr(sz[2], sz[3])
;  continum = fltarr(sz[2], sz[3])
;  width = fltarr(sz[2], sz[3])
;  raielarge = fltarr(sz[1]*2)
;  xx = findgen(sz[1]*2)-sz[1]/2

;  channelWidth = trailer.xi1 / sz[1]

;  for x=0, sz[2]-1 do begin
;    for y=0, sz[3]-1 do begin
;      raie = cube[*,x,y]
;      continum[x,y] = continum(raie, level)

;      raie80 = (raie>continum[x,y]) - continum[x,y]

;      sn = computeSignalNoiseValue(raie80, signal, noise)

;      mono[x,y] = signal

;      bary = bary(raie80)
;      baryLambda = bary[0] * channelWidth + trailer.xl1
;      z = (baryLambda / trailer.xl0) - 1
;      rv[x,y] = ((z + 1)^2 - 1)/((z + 1)^2 + 1) * c + trailer.corrv
;      ; Pour determiner la largeur de la
;      ; raie d'emission, on prend le barycentre et on regarde la largeur a
;      ; demie hauteur du la raie autour du barycentre
;      raielarge[0:sz[1]/2-1] = raie[sz[1]/2:sz[1]-1]
;      raielarge[sz[1]/2:sz[1]*1.5-1] = raie
;      raielarge[sz[1]*1.5:sz[1]*2-1] = raie[0:sz[1]/2-1]

;      candidates = where(raielarge ge max(raielarge)/2)
;      good = shift(candidates - shift(candidates, 1), -1)
;      goodidx = where(candidates eq floor(bary[0]+sz[1]/2))

;      if (n_elements(goodidx) eq 1) and (goodidx[0] eq -1) then begin
;        tempo = min(abs(candidates-floor(bary[0]+sz[1]/2)), goodidx)
;      endif

;      i = 0
;      while 1 do begin
;        idx = goodidx-i
;        if idx lt 0 then break

;        if good[idx] ne 1 then begin
;          good[idx] = 1
;          if idx ge 1 then good[0:idx-1] = 0
;          break
;        endif

;        i = i+1
;      endwhile

;      szg = n_elements(good)
;      i = 0
;      while 1 do begin
;        idx = goodidx+i
;        if idx ge szg then break

;        if good[idx] ne 1 then begin
;          good[idx] = 1
;          if idx le szg-2 then good[idx+1:szg-1] = 0
;          break
;        endif

;        i = i + 1
;      endwhile

;      width[x,y] = total(good)
;    endfor
;  endfor

;  return, rv

;end
