;***********
; ADHOCw ad3 trailer format:
; http://www-obs.cnrs-mrs.fr/adhoc/adw_what.htm#new_format
;***********
pro ad_trailer__define
COMPILE_OPT IDL2, HIDDEN
  tmp = {ad_trailer, $
    nbdim: 0L,     $     ; Amount of dimensions
    id:    bytarr(8), $  ; Identification
    lx:    0L,     $     ; dimension in X
    ly:    0L,     $     ; dimension in Y
    lz:    0L,     $     ; dimension in Z
    scale: 0.0,    $     ; arcsec/pixel
    ix0:   1L,     $     ; top-left corner (ADHOC coordinates)
    iy0:   1L,     $     ; bottom-right corner (ADHOC coordinates)
    zoom:  1.0     $     ; zoom (??)
  }
end
