function adpToAd3Trailer, filename, calibwl, scanwl
COMPILE_OPT IDL2

  readcol, filename[0], data, format='a', /silent, skipline=1

  trailer = {ad3_trailer}

  trailer.nbdim = 3
  trailer.lx = data[0]
  trailer.ly = data[1]
  trailer.lz = data[2]
  trailer.scale = data[17]

  trailer.xl1 = data[14]
  trailer.xi1 = data[13]
  trailer.vr0 = data[15]
  trailer.corrv = data[16]
  trailer.p0 = data[7]
  trailer.xlp = data[8]
  trailer.xl0 = data[11] ; xlneb
  
  lambda_scan = data[12]; xlbneb
  ; On recalcule certaines valeurs qui sont mal calculees par ADHOCw...

;  trailer.xl1 = lambda_scan-trailer.xi1/2.0

  c = 299792.458D
  trailer.xik = c/trailer.p0

  calibwl = data[9]
  scanwl = data[13]

  return, trailer
end
